---
title: generate-id
slug: Web/XPath/Functions/generate-id
tags:
  - XSLT
  - XSLT_Reference
---
<p>{{ XsltRef() }}</p>

<p><br>
 The <code>generate-id</code> function generates a unique id for the first node in a given node-set and returns a string containing that id.</p>

<h3 id="Syntax">Syntax</h3>

<pre class="eval">generate-id( [<em>node-set</em>] )
</pre>

<h3 id="Arguments">Arguments</h3>

<dl>
 <dt><code><em>node-set</em></code> (optional)</dt>
 <dd>An id will be generated for the first node in this node-set. If omitted, the current context node will be used.</dd>
</dl>

<h3 id="Returns">Returns</h3>

<p>A string containing the generated id.</p>

<h3 id="Notes">Notes</h3>

<ul>
 <li>The same id must be generated every time for the same node in the current document in the current transformation.</li>
</ul>

<ul>
 <li>The generated id may not be the same in subsequent transformations.</li>
</ul>

<p>This function is an XSLT-specific addition to XPath. It is not a part of the core XPath function library.</p>

<h3 id="Defined">Defined</h3>

<p><a class="external" href="http://www.w3.org/TR/xslt#function-generate-id">XSLT 1.0 12.4</a></p>

<h3 id="Gecko_support">Gecko support</h3>

<p>Supported.</p>
